var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React, { useCallback } from 'react';
import { StyleSheet, View } from 'react-native';
import { useStack } from '../hooks';
import { preparePaddings } from '../helpers/preparePaddings';
export var Stack = function (_a) {
    var children = _a.children, spaces = _a.spaces, padding = _a.padding, style = _a.style, props = __rest(_a, ["children", "spaces", "padding", "style"]);
    var globalConfig = useStack();
    // TODO refactor
    var stackSpaces = spaces !== null && spaces !== void 0 ? spaces : globalConfig.spaces;
    var stackPadding = padding !== null && padding !== void 0 ? padding : globalConfig.padding;
    var renderDivider = function () { return (React.createElement(View, { style: StyleSheet.flatten([
            {
                minWidth: stackSpaces,
                minHeight: stackSpaces,
            },
            // TODO random color
            globalConfig.debug && { backgroundColor: '#f0f' },
        ]) })); };
    var renderStack = useCallback(function () {
        // TODO const
        var elements = Array.isArray(children) ? children : [children];
        elements = elements.filter(function (child) {
            return Array.isArray(child) || React.isValidElement(child);
        });
        // TODO move to new function/split
        return elements.reduce(function (children, child, index) {
            if (children.length === 0) {
                return [child];
            }
            var addSpaces = function () {
                if (typeof stackSpaces !== 'number' &&
                    typeof stackSpaces !== 'string') {
                    return [];
                }
                return React.cloneElement(renderDivider(), {
                    key: "stack-divider-" + index,
                });
            };
            return __spreadArrays(children, [addSpaces(), child]);
        }, []);
        // TODO fix updaters
    }, []);
    return (React.createElement(View, __assign({}, props, { style: StyleSheet.flatten([style, preparePaddings(stackPadding || 0)]) }), renderStack()));
};
